<template class="filter_container">
  <div style="margin-top: 21px">
    <h2>Фильтровать по:</h2>
    <OptionSelector
      caption="Преподавателю:"
      :initial-option="selectedTutor"
      :options="tutors"
      @selected="setTutor"
    />
    <OptionSelector
      caption="Предмету:"
      :initial-option="selectedCourse"
      :options="courses"
      @selected="setCourse"
    />
    <OptionSelector
      caption="Оценке:"
      :initial-option="selectedScore"
      :options="scores"
      @selected="setScore"
    />
    <div class="selector_container">
      <b class="caption">Дате отзыва:</b>
      <br />
      <input class="selector" type="date" v-model="selectedDateStart" />
      <div class="caption inline" style="float: right; margin-bottom: 20px">от:</div>
      <input class="selector" type="date" v-model="selectedDateEnd" />
      <div class="caption inline" style="float: right">до:</div>
    </div>
    <div class="selector_container">
      <b class="inline caption">Году обучения:</b>
      <input
        class="selector"
        v-model="selectedEduStart"
        type="number"
        min="2010"
        max="2050"
        maxlength="4"
      />
    </div>
    <template v-if="filtersChanged">
      <div class="selector_container">
        <button style="float: right" @click="applyFilter">
          Применить фильтр
        </button>
      </div>
    </template>
  </div>
</template>

<script>
import OptionSelector from "./OptionSelector";
import axios from "axios";
import moment from "moment";

export default {
  name: "FilterSelector",
  components: { OptionSelector },
  data() {
    let noFilterArray = [{ value: null, text: "не фильтровать" }];
    let array = [
      { value: 1, text: "1" },
      { value: 2, text: "2" },
      { value: 3, text: "3" },
      { value: 4, text: "4" },
      { value: 5, text: "5" },
      { value: 6, text: "6" },
      { value: 7, text: "7" },
      { value: 8, text: "8" },
      { value: 9, text: "9" },
      { value: 10, text: "10" },
      noFilterArray[0],
    ];
    return {
      noFilterArray: [...noFilterArray],
      tutors: [...noFilterArray],
      selectedTutor: null,
      courses: [...noFilterArray],
      selectedCourse: null,
      scores: [...array],
      selectedScore: null,
      selectedDateStart: null,
      selectedDateEnd: null,
      selectedEduStart: null,
      filtersChanged: false,
      filter: [],
      url: String(process.env.VUE_APP_API_URL),
    };
  },
  emits: ["submit_filter"],
  methods: {
    setTutor(val) {
      this.selectedTutor = val;
      this.update();
    },
    setCourse(val) {
      this.selectedCourse = val;
      this.update();
    },
    setScore(val) {
      this.selectedScore = val;
      this.update();
    },
    update() {
      let filter = [];
      if (this.selectedTutor) filter.push("tutor_id=" + this.selectedTutor);

      if (this.selectedCourse) filter.push("course_id=" + this.selectedCourse);

      if (this.selectedScore) filter.push("score=" + this.selectedScore);

      if (this.selectedDateStart)
        filter.push(
          "review_date_start=" + this.formatDate(this.selectedDateStart)
        );

      if (this.selectedDateEnd)
        filter.push("review_date_end=" + this.formatDate(this.selectedDateEnd));

      if (this.selectedEduStart)
        filter.push("edu_start=" + this.selectedEduStart);

      this.filter = filter;
      this.filtersChanged = true;
    },
    applyFilter() {
      this.$emit("submit_filter", this.filter);
      this.filtersChanged = false;
    },
    formatTutor(tutor) {
      if (tutor)
        return (
          tutor.lastName +
          " " +
          tutor.firstName.charAt(0) +
          ". " +
          tutor.patronymic.charAt(0) +
          ". ,"
        );
      return "";
    },
    acceptTutorsList(response) {
      this.tutors = response.data.tutorList
        .map((tutor) => ({
          text: this.formatTutor(tutor),
          value: tutor.tutorId,
        }))
        .concat(this.noFilterArray);
    },
    acceptCoursesList(response) {
      this.courses = response.data.courseList
        .map((course) => ({
          text: course.courseName,
          value: course.courseId,
        }))
        .concat(this.noFilterArray);
    },
    formatDate(date) {
      return moment(date).format("yyyy-MM-DD");
    },
  },
  watch: {
    selectedTutor() {
      this.update();
    },
    selectedCourse() {
      this.update();
    },
    selectedScore() {
      this.update();
    },
    selectedDateStart() {
      this.update();
    },
    selectedDateEnd() {
      this.update();
    },
    selectedEduStart() {
      this.update();
    },
  },
  mounted() {
    axios.get(this.url + "tutor").then(this.acceptTutorsList);
    axios.get(this.url + "course").then(this.acceptCoursesList);
  },
};
</script>

<style scoped>
.filter_container * {
  margin: 50px;
}
</style>
